# -*- coding: utf-8 -*-
# This file is auto-generated, don't edit it. Thanks.
from __future__ import annotations

from typing import Dict

from alibabacloud_tea_openapi import utils_models as open_api_util_models
from alibabacloud_tea_openapi.client import Client as OpenApiClient
from alibabacloud_tea_openapi.utils import Utils
from darabonba.core import DaraCore as DaraCore
from darabonba.runtime import RuntimeOptions

from agentbay.api import models as main_models

"""
"""


class Client(OpenApiClient):

    def __init__(
        self,
        config: open_api_util_models.Config,
    ):
        super().__init__(config)
        self._signature_algorithm = "v2"
        self._endpoint_rule = ""
        self.check_config(config)
        self._endpoint = self.get_endpoint(
            "wuyingai",
            self._region_id,
            self._endpoint_rule,
            self._network,
            self._suffix,
            self._endpoint_map,
            self._endpoint,
        )

    def get_endpoint(
        self,
        product_id: str,
        region_id: str,
        endpoint_rule: str,
        network: str,
        suffix: str,
        endpoint_map: Dict[str, str],
        endpoint: str,
    ) -> str:
        if not DaraCore.is_null(endpoint):
            return endpoint
        if not DaraCore.is_null(endpoint_map) and not DaraCore.is_null(
            endpoint_map.get(region_id)
        ):
            return endpoint_map.get(region_id)
        return Utils.get_endpoint_rules(
            product_id, region_id, endpoint_rule, network, suffix
        )

    def call_mcp_tool_with_options(
        self,
        request: main_models.CallMcpToolRequest,
        runtime: RuntimeOptions,
    ) -> main_models.CallMcpToolResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.args):
            body["Args"] = request.args
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.external_user_id):
            body["ExternalUserId"] = request.external_user_id
        if not DaraCore.is_null(request.image_id):
            body["ImageId"] = request.image_id
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        if not DaraCore.is_null(request.server):
            body["Server"] = request.server
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        if not DaraCore.is_null(request.tool):
            body["Tool"] = request.tool
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="CallMcpTool",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.CallMcpToolResponse(), self.call_api(params, req, runtime)
        )

    async def call_mcp_tool_with_options_async(
        self,
        request: main_models.CallMcpToolRequest,
        runtime: RuntimeOptions,
    ) -> main_models.CallMcpToolResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.args):
            body["Args"] = request.args
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.external_user_id):
            body["ExternalUserId"] = request.external_user_id
        if not DaraCore.is_null(request.image_id):
            body["ImageId"] = request.image_id
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        if not DaraCore.is_null(request.server):
            body["Server"] = request.server
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        if not DaraCore.is_null(request.tool):
            body["Tool"] = request.tool
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="CallMcpTool",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.CallMcpToolResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def call_mcp_tool(
        self,
        request: main_models.CallMcpToolRequest,
    ) -> main_models.CallMcpToolResponse:
        runtime = RuntimeOptions()
        return self.call_mcp_tool_with_options(request, runtime)

    async def call_mcp_tool_async(
        self,
        request: main_models.CallMcpToolRequest,
    ) -> main_models.CallMcpToolResponse:
        runtime = RuntimeOptions()
        return await self.call_mcp_tool_with_options_async(request, runtime)

    def create_mcp_session_with_options(
        self,
        request: main_models.CreateMcpSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.CreateMcpSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.context_id):
            body["ContextId"] = request.context_id
        if not DaraCore.is_null(request.external_user_id):
            body["ExternalUserId"] = request.external_user_id
        if not DaraCore.is_null(request.image_id):
            body["ImageId"] = request.image_id
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="CreateMcpSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.CreateMcpSessionResponse(), self.call_api(params, req, runtime)
        )

    async def create_mcp_session_with_options_async(
        self,
        request: main_models.CreateMcpSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.CreateMcpSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.context_id):
            body["ContextId"] = request.context_id
        if not DaraCore.is_null(request.external_user_id):
            body["ExternalUserId"] = request.external_user_id
        if not DaraCore.is_null(request.image_id):
            body["ImageId"] = request.image_id
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="CreateMcpSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.CreateMcpSessionResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def create_mcp_session(
        self,
        request: main_models.CreateMcpSessionRequest,
    ) -> main_models.CreateMcpSessionResponse:
        runtime = RuntimeOptions()
        return self.create_mcp_session_with_options(request, runtime)

    async def create_mcp_session_async(
        self,
        request: main_models.CreateMcpSessionRequest,
    ) -> main_models.CreateMcpSessionResponse:
        runtime = RuntimeOptions()
        return await self.create_mcp_session_with_options_async(request, runtime)

    def delete_context_with_options(
        self,
        request: main_models.DeleteContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.DeleteContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.id):
            body["Id"] = request.id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="DeleteContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.DeleteContextResponse(), self.call_api(params, req, runtime)
        )

    async def delete_context_with_options_async(
        self,
        request: main_models.DeleteContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.DeleteContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.id):
            body["Id"] = request.id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="DeleteContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.DeleteContextResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def delete_context(
        self,
        request: main_models.DeleteContextRequest,
    ) -> main_models.DeleteContextResponse:
        runtime = RuntimeOptions()
        return self.delete_context_with_options(request, runtime)

    async def delete_context_async(
        self,
        request: main_models.DeleteContextRequest,
    ) -> main_models.DeleteContextResponse:
        runtime = RuntimeOptions()
        return await self.delete_context_with_options_async(request, runtime)

    def get_context_with_options(
        self,
        request: main_models.GetContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.allow_create):
            body["AllowCreate"] = request.allow_create
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetContextResponse(), self.call_api(params, req, runtime)
        )

    async def get_context_with_options_async(
        self,
        request: main_models.GetContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.allow_create):
            body["AllowCreate"] = request.allow_create
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetContextResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def get_context(
        self,
        request: main_models.GetContextRequest,
    ) -> main_models.GetContextResponse:
        runtime = RuntimeOptions()
        return self.get_context_with_options(request, runtime)

    async def get_context_async(
        self,
        request: main_models.GetContextRequest,
    ) -> main_models.GetContextResponse:
        runtime = RuntimeOptions()
        return await self.get_context_with_options_async(request, runtime)

    def get_label_with_options(
        self,
        request: main_models.GetLabelRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetLabelResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetLabel",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetLabelResponse(), self.call_api(params, req, runtime)
        )

    async def get_label_with_options_async(
        self,
        request: main_models.GetLabelRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetLabelResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetLabel",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetLabelResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def get_label(
        self,
        request: main_models.GetLabelRequest,
    ) -> main_models.GetLabelResponse:
        runtime = RuntimeOptions()
        return self.get_label_with_options(request, runtime)

    async def get_label_async(
        self,
        request: main_models.GetLabelRequest,
    ) -> main_models.GetLabelResponse:
        runtime = RuntimeOptions()
        return await self.get_label_with_options_async(request, runtime)

    def get_link_with_options(
        self,
        request: main_models.GetLinkRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetLinkResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetLink",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetLinkResponse(), self.call_api(params, req, runtime)
        )

    async def get_link_with_options_async(
        self,
        request: main_models.GetLinkRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetLinkResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetLink",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetLinkResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def get_link(
        self,
        request: main_models.GetLinkRequest,
    ) -> main_models.GetLinkResponse:
        runtime = RuntimeOptions()
        return self.get_link_with_options(request, runtime)

    async def get_link_async(
        self,
        request: main_models.GetLinkRequest,
    ) -> main_models.GetLinkResponse:
        runtime = RuntimeOptions()
        return await self.get_link_with_options_async(request, runtime)

    def get_mcp_resource_with_options(
        self,
        request: main_models.GetMcpResourceRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetMcpResourceResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetMcpResource",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetMcpResourceResponse(), self.call_api(params, req, runtime)
        )

    async def get_mcp_resource_with_options_async(
        self,
        request: main_models.GetMcpResourceRequest,
        runtime: RuntimeOptions,
    ) -> main_models.GetMcpResourceResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="GetMcpResource",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.GetMcpResourceResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def get_mcp_resource(
        self,
        request: main_models.GetMcpResourceRequest,
    ) -> main_models.GetMcpResourceResponse:
        runtime = RuntimeOptions()
        return self.get_mcp_resource_with_options(request, runtime)

    async def get_mcp_resource_async(
        self,
        request: main_models.GetMcpResourceRequest,
    ) -> main_models.GetMcpResourceResponse:
        runtime = RuntimeOptions()
        return await self.get_mcp_resource_with_options_async(request, runtime)

    def list_contexts_with_options(
        self,
        request: main_models.ListContextsRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ListContextsResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ListContexts",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ListContextsResponse(), self.call_api(params, req, runtime)
        )

    async def list_contexts_with_options_async(
        self,
        request: main_models.ListContextsRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ListContextsResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ListContexts",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ListContextsResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def list_contexts(
        self,
        request: main_models.ListContextsRequest,
    ) -> main_models.ListContextsResponse:
        runtime = RuntimeOptions()
        return self.list_contexts_with_options(request, runtime)

    async def list_contexts_async(
        self,
        request: main_models.ListContextsRequest,
    ) -> main_models.ListContextsResponse:
        runtime = RuntimeOptions()
        return await self.list_contexts_with_options_async(request, runtime)

    def list_session_with_options(
        self,
        request: main_models.ListSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ListSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ListSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ListSessionResponse(), self.call_api(params, req, runtime)
        )

    async def list_session_with_options_async(
        self,
        request: main_models.ListSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ListSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.max_results):
            body["MaxResults"] = request.max_results
        if not DaraCore.is_null(request.next_token):
            body["NextToken"] = request.next_token
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ListSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ListSessionResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def list_session(
        self,
        request: main_models.ListSessionRequest,
    ) -> main_models.ListSessionResponse:
        runtime = RuntimeOptions()
        return self.list_session_with_options(request, runtime)

    async def list_session_async(
        self,
        request: main_models.ListSessionRequest,
    ) -> main_models.ListSessionResponse:
        runtime = RuntimeOptions()
        return await self.list_session_with_options_async(request, runtime)

    def modify_context_with_options(
        self,
        request: main_models.ModifyContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ModifyContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.id):
            body["Id"] = request.id
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ModifyContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ModifyContextResponse(), self.call_api(params, req, runtime)
        )

    async def modify_context_with_options_async(
        self,
        request: main_models.ModifyContextRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ModifyContextResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.id):
            body["Id"] = request.id
        if not DaraCore.is_null(request.name):
            body["Name"] = request.name
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ModifyContext",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ModifyContextResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def modify_context(
        self,
        request: main_models.ModifyContextRequest,
    ) -> main_models.ModifyContextResponse:
        runtime = RuntimeOptions()
        return self.modify_context_with_options(request, runtime)

    async def modify_context_async(
        self,
        request: main_models.ModifyContextRequest,
    ) -> main_models.ModifyContextResponse:
        runtime = RuntimeOptions()
        return await self.modify_context_with_options_async(request, runtime)

    def release_mcp_session_with_options(
        self,
        request: main_models.ReleaseMcpSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ReleaseMcpSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ReleaseMcpSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ReleaseMcpSessionResponse(), self.call_api(params, req, runtime)
        )

    async def release_mcp_session_with_options_async(
        self,
        request: main_models.ReleaseMcpSessionRequest,
        runtime: RuntimeOptions,
    ) -> main_models.ReleaseMcpSessionResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="ReleaseMcpSession",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.ReleaseMcpSessionResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def release_mcp_session(
        self,
        request: main_models.ReleaseMcpSessionRequest,
    ) -> main_models.ReleaseMcpSessionResponse:
        runtime = RuntimeOptions()
        return self.release_mcp_session_with_options(request, runtime)

    async def release_mcp_session_async(
        self,
        request: main_models.ReleaseMcpSessionRequest,
    ) -> main_models.ReleaseMcpSessionResponse:
        runtime = RuntimeOptions()
        return await self.release_mcp_session_with_options_async(request, runtime)

    def set_label_with_options(
        self,
        request: main_models.SetLabelRequest,
        runtime: RuntimeOptions,
    ) -> main_models.SetLabelResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="SetLabel",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.SetLabelResponse(), self.call_api(params, req, runtime)
        )

    async def set_label_with_options_async(
        self,
        request: main_models.SetLabelRequest,
        runtime: RuntimeOptions,
    ) -> main_models.SetLabelResponse:
        request.validate()
        body = {}
        if not DaraCore.is_null(request.authorization):
            body["Authorization"] = request.authorization
        if not DaraCore.is_null(request.labels):
            body["Labels"] = request.labels
        if not DaraCore.is_null(request.session_id):
            body["SessionId"] = request.session_id
        req = open_api_util_models.OpenApiRequest(body=Utils.parse_to_map(body))
        params = open_api_util_models.Params(
            action="SetLabel",
            version="2025-05-06",
            protocol="HTTPS",
            pathname="/",
            method="POST",
            auth_type="Anonymous",
            style="RPC",
            req_body_type="formData",
            body_type="json",
        )
        return DaraCore.from_map(
            main_models.SetLabelResponse(),
            await self.call_api_async(params, req, runtime),
        )

    def set_label(
        self,
        request: main_models.SetLabelRequest,
    ) -> main_models.SetLabelResponse:
        runtime = RuntimeOptions()
        return self.set_label_with_options(request, runtime)

    async def set_label_async(
        self,
        request: main_models.SetLabelRequest,
    ) -> main_models.SetLabelResponse:
        runtime = RuntimeOptions()
        return await self.set_label_with_options_async(request, runtime)
